#DEFINE ImageLockModeRead   1 
#DEFINE ImageLockModeWrite   2 
#DEFINE ImageLockModeUserInputBuf 4

#define    PixelFormatIndexed      0x00010000 && Indexes into a palette
#define    PixelFormatGDI          0x00020000 && Is a GDI-supported format
#define    PixelFormatAlpha        0x00040000 && Has an alpha component
#define    PixelFormatPAlpha       0x00080000 && Pre-multiplied alpha
#define    PixelFormatExtended     0x00100000 && Extended color 16 bits/channel
#define    PixelFormatCanonical    0x00200000 

#define    PixelFormatUndefined       0
#define    PixelFormatDontCare        0


#Define    PixelFormat1bppIndexed     (1 + (0x0100)+PixelFormatIndexed+PixelFormatGDI)
#Define    PixelFormat4bppIndexed     (2 + (0x0400)+PixelFormatIndexed+PixelFormatGDI)
#Define    PixelFormat8bppIndexed     (3 + (0x0800)+PixelFormatIndexed+PixelFormatGDI)
#Define    PixelFormat16bppGrayScale  (4 + (0x1000)+PixelFormatExtended)
#Define    PixelFormat16bppRGB555     (5 + (0x1000)+PixelFormatGDI)
#Define    PixelFormat16bppRGB565     (6 + (0x1000)+PixelFormatGDI)
#Define    PixelFormat16bppARGB1555   (7 + (0x1000)+PixelFormatAlpha+PixelFormatGDI)
#Define    PixelFormat24bppRGB        (8 + (0x1800)+PixelFormatGDI)
#Define    PixelFormat32bppRGB        (9 + (0x2000)+PixelFormatGDI)
#Define    PixelFormat32bppARGB       (10+ (0x2000)+PixelFormatAlpha+PixelFormatGDI+PixelFormatCanonical)
#Define    PixelFormat32bppPARGB      (11+ (0x2000)+PixelFormatAlpha+PixelFormatPAlpha+PixelFormatGDI)
#Define    PixelFormat48bppRGB        (12+ (0x3000)+PixelFormatExtended)
#Define    PixelFormat64bppARGB       (13+ (0x4000)+PixelFormatAlpha+PixelFormatCanonical+PixelFormatExtended)
#Define    PixelFormat64bppPARGB      (14+ (0x4000)+PixelFormatAlpha+PixelFormatPAlpha+PixelFormatExtended)
#Define    PixelFormatMax             15


Set Talk On

Local loBitmap As xfcBitmap
Local m.loBitmapData As xfcbitmapdata

m.loBitmap = _Screen.System.Drawing.Bitmap.FromFile(Getpict())


m.lnPixelFormat = m.loBitmap.PixelFormat

?"m.lnPixelFormat", m.lnPixelFormat

m.lnbits_per_pixel = 32

Do Case

	Case m.lnPixelFormat = PixelFormat1bppIndexed
		m.lnbits_per_pixel = 1
	Case m.lnPixelFormat =  PixelFormat4bppIndexed
		m.lnbits_per_pixel = 4
	Case m.lnPixelFormat =  PixelFormat8bppIndexed
		m.lnbits_per_pixel = 8
	Case m.lnPixelFormat =  PixelFormat16bppARGB1555
	Case m.lnPixelFormat =  PixelFormat16bppGrayScale
	Case m.lnPixelFormat =  PixelFormat16bppRGB555
	Case m.lnPixelFormat =  PixelFormat16bppRGB565
		m.lnbits_per_pixel = 16
	Case m.lnPixelFormat =  PixelFormat24bppRGB
		m.lnbits_per_pixel = 24
	Case m.lnPixelFormat =  PixelFormat32bppARGB
	Case m.lnPixelFormat =  PixelFormat32bppPARGB
	Case m.lnPixelFormat =  PixelFormat32bppRGB
		m.lnbits_per_pixel = 32
	Case m.lnPixelFormat =  PixelFormat48bppRGB
		m.lnbits_per_pixel = 48
	Case m.lnPixelFormat =  PixelFormat64bppARGB
	Case m.lnPixelFormat =  PixelFormat64bppPARGB
		m.lnbits_per_pixel = 64
Endcase

?"m.lnbits_per_pixel",m.lnbits_per_pixel

m.lnWidth = m.loBitmap.Width
m.lnHeight = m.loBitmap.Height

m.loRect = _Screen.System.Drawing.Rectangle.New(0, 0, m.loBitmap.Width, loBitmap.Height)

m.loBitmapData = m.loBitmap.LockBits(m.loRect, ImageLockModeRead, m.lnPixelFormat)

Local m.lobitmap2 As xfcBitmap

m.lobitmap2 = _Screen.System.Drawing.Bitmap.New(m.lnWidth, m.lnHeight, 1, m.lnbits_per_pixel, m.loBitmapData.Scan0)

m.loBitmap.UnlockBits(m.loBitmapData)

m.lobitmap2.Save("c:\test.png")